// =============================================================================
// webks.de SCSS Mixins: Default Objects
// =============================================================================

// =============================================================================
//  Icons
// =============================================================================
@mixin ico-replacement($icon-name: null, $icon-size: null, $icon-wrapper-width: null) {
  // Replaces the text / label with an icon
  // !! If you have any chance to cleanly hide the label dont this instead of using this mixin.

  // We need to use the following approach because we use display: inline-flex for the icons
  // So a simple text-indent is not working, becasue flexbox handles the text-node as an "element"
  font-weight: normal !important;
  text-indent: -200vw !important;
  overflow:hidden !important;
  justify-content:flex-end !important; // ensure the text is moved out the icon container to the left side
  white-space: nowrap !important;
  text-align:left !important;

  @if($icon-size !=null) {
    font-size: $icon-size;
  }
  @if($icon-wrapper-width !=null) {
    width: $icon-wrapper-width;
  } @else if($icon-size !=null and $icon-wrapper-width==null) {
    width: $icon-size;
  } @else {
    width: $icon-size-md;
  }
  &::before {
    font-family: $iconfont-family;
    text-indent: 0;
    float: right;
    text-align: center;
    width: 100%;
    min-width:100%;
    order:100; // Ensure the icon is the right element
    @if($icon-name !=null) {
      content: $icon-name;
    }
  }
}

@mixin get-ico($icon-name: null) {
  // Gets only the icon letter (for custom implementation)
  @if($icon-name !=null) {
    &::before {
      content: $icon-name;
      font: $iconfont;
    }
  }
  @else {
    @error "You have to define an icon: eg: $ico-star.";
  }
}

@mixin get-ico-only($icon-name: null) {
  // Gets only the icon letter (for custom implementation)
  @if($icon-name !=null) {
    content: $icon-name;
    font-family: $iconfont-family;
  }
  @else {
    @error "You have to define an icon: eg: $ico-star.";
  }
}

// Animated Burger Icon
// -- splitted in multiple mixins per state because the context differs.
@mixin animated-burger($animated-burger-icon-width: $animated-burger-icon-width-default, $animated-burger-icon-bar-height: $animated-burger-icon-bar-height-default, $animated-burger-icon-bar-spacing: $animated-burger-icon-bar-spacing-default, $animated-burger-icon-bar-radius: $animated-burger-icon-bar-radius-default, $animated-burger-icon-height: 3 * $animated-burger-icon-bar-height + 2 * $animated-burger-icon-bar-spacing) {
  width: $animated-burger-icon-width;
  height: $animated-burger-icon-height;
  position: relative;
  transform: rotate(0deg);
  transition: 0.95s ease-in-out;
  cursor: pointer;
  background: none;
  display:block;
  span {
    display: block;
    position: absolute;
    height: $animated-burger-icon-bar-height;
    width: 100%;
    background: $animated-burger-icon-color;
    border-radius: $animated-burger-icon-bar-radius;
    opacity: 1;
    left: 0;
    transform: rotate(0deg);
    transition: 0.55s ease-in-out;
    &:nth-child(1) {
      top: 0;
    }
    &:nth-child(2),
    &:nth-child(3) {
      top: $animated-burger-icon-bar-height + $animated-burger-icon-bar-spacing;
    }
    &:nth-child(4) {
      top: ($animated-burger-icon-bar-height * 2) + ($animated-burger-icon-bar-spacing * 2);
    }
  }
  &::after {
    display: none;
  }
}

// Tapped / hovered
@mixin animated-burger-active($animated-burger-icon-width: $animated-burger-icon-width-default, $animated-burger-icon-bar-height: $animated-burger-icon-bar-height-default, $animated-burger-icon-bar-spacing: $animated-burger-icon-bar-spacing-default, $animated-burger-icon-bar-radius: $animated-burger-icon-bar-radius-default, $animated-burger-icon-height: 3 * $animated-burger-icon-bar-height + 2 * $animated-burger-icon-bar-spacing) {
  span {
    background-color: $animated-burger-icon-color-active;
  }
}

// Opened > Transform to "X"
@mixin animated-burger-open($animated-burger-icon-width: $animated-burger-icon-width-default, $animated-burger-icon-bar-height: $animated-burger-icon-bar-height-default, $animated-burger-icon-bar-spacing: $animated-burger-icon-bar-spacing-default, $animated-burger-icon-bar-radius: $animated-burger-icon-bar-radius-default, $animated-burger-icon-height: 3 * $animated-burger-icon-bar-height + 2 * $animated-burger-icon-bar-spacing) {
  span {
    background-color: $animated-burger-icon-color-active;
    &:nth-child(1) {
      top: $animated-burger-icon-bar-height + $animated-burger-icon-bar-spacing;
      width: 0;
      left: 50%;
    }
    &:nth-child(2) {
      transform: rotate(45deg);
    }
    &:nth-child(3) {
      transform: rotate(-45deg);
    }
    &:nth-child(4) {
      top: $animated-burger-icon-bar-height + $animated-burger-icon-bar-spacing;
      width: 0;
      left: 50%;
    }
  }
}

// =============================================================================
//  Slideshows (Slick)
// =============================================================================

// .slick formatter to show the controls outside the content, not as overlay
@mixin slick-controls-outside($arrow-size: $icon-size-md){
  // &.slick-dotted{}
  // Reserve space for the dots AND arrows
  // Needs to be padding instead of margin because of overflow:hidden on the wrapper
  .slick-slider{
    padding-bottom: calc(#{$arrow-size * 2} + .35rem);
  }
  .slick-dots{
    // $slider-dot-size
    width:auto;
    bottom:0;
    transform: translateY(-50%);
    li:not(.slick-active):not(:hover) button::before{
      background-color: $black-glass;
    }
  }
  .slick__arrow{
    position:absolute;
    width:auto;
    height:auto;
    top:auto;
    bottom:0;
    left:auto;
    right:0;
    display:flex;
    > button{
      position:static;
      color: $text-color;
      transform:none !important;
      width:($arrow-size * 2) !important;
      height:($arrow-size * 2) !important;
      &::before{
        font-size:$arrow-size !important;
        text-shadow:none;
      }
      &:hover{
        transform:none !important;
        color: $primary-color;
      }
    }
  }
}

// =============================================================================
//  Box Styles
// =============================================================================
@mixin box-style($box-style-color: $box-style-default-style) {
  border-width: 1px;
  border-style: solid;

  @if variable-exists(box-style-inner-space-v){
    @include space($spacing: $box-style-inner-space-v $box-style-inner-space-h, $type: padding);
  }@else{
    // Fallback - old static values
    padding: $box-style-padding-v $box-style-padding-h;
  }

  @if variable-exists(box-style-outer-space-bottom){
    @include space($spacing: $box-style-outer-space-bottom, $direction: bottom);
  }@else{
    // Fallback - old static values
    margin-bottom: $box-style-margin-bottom; // Color
  }

  @include box-style-mod($box-style-color);
  @include headings-color(currentColor);
  // Prevent double spacing at the bottom - we dont do this for all (*) elements, because sometimes you will put just an title in a single paragraph,
  // so this would destroy our default text style.
  >.button,
  >p,
  >*>.button {
    &:last-child {
      margin-bottom: 0;
    }
  }
}

// Box Style Modifier (for custom use via mixin)
$box-style-default-style: $grey-light !default; // this needs to be one of the above defined keys.
$box-style-smart-scale-threshold: 65% !default;
$box-style-light-colors-foreground-color: $body-font-color !default; // You can also use the current box styles fg color with 'current'
$box-style-light-colors-background-color: $body-font-color !default; // You can also use the current box styles bg color with 'current'
$box-style-dark-colors-foreground-color: $white !default; // You can also use the current box styles fg color with 'current'
$box-style-dark-colors-background-color: 'current' !default; // You can also use the current box styles bg color with 'current'

@mixin box-style-mod($box-style-color: $box-style-default-style, $box-style-text-color-override: null, $box-style-bg-color-override: null, $box-style-border-color-override: null) {
  // Define vars
  $box-style-bg-color: $box-style-color;
  $box-style-border-color: $box-style-color;
  @if($box-style-bg-color-override !=null) {
    $box-style-bg-color: $box-style-bg-color-override;
  }
  @if($box-style-border-color-override !=null) {
    $box-style-border-color: $box-style-border-color-override;
  }
  // Automaticaly detect the right text color
  // You can modify the automatism by chainging $box-style-smart-scale-threshold
  // You can also modify the default fore- and background-colors by changing $box-style-light-colors-foreground-color, ...
  // If you need a custom color use the contextual-contents-color() mixin.
  $box-style-text-color: smart-scale($box-style-bg-color, 100%, $box-style-smart-scale-threshold); // Ensure we have a solid text color, even if the box-style-color is RGBA / transparent (increased the threshold a little to switch to white text a little earlier - 50% would work also)
  $box-style-text-color: rgba-to-rgb($box-style-text-color);
  @if $box-style-text-color-override !=null {
    $box-style-text-color: $box-style-text-color-override;
  } @else {
    // $black is often not really black. So if smart-scale() discovered black / white
    // we rematch it with our variables.
    @if($box-style-text-color==black or $box-style-text-color=="black") {
      $box-style-text-color: $body-font-color;
      @include contextual-contents-color(
        $foreground-color: if($box-style-light-colors-foreground-color == "current", $box-style-text-color, $box-style-light-colors-foreground-color),
        $background-color: if($box-style-light-colors-background-color == "current", $box-style-color, $box-style-light-colors-background-color)
      );
    }
    @else if($box-style-text-color==white or $box-style-text-color=="white") {
      $box-style-text-color: $white;
      @include contextual-contents-color(
        $foreground-color: if($box-style-dark-colors-foreground-color == "current", $box-style-text-color, $box-style-dark-colors-foreground-color),
        $background-color: if($box-style-dark-colors-background-color == "current", $box-style-color, $box-style-dark-colors-background-color)
      );
    }
  }
  background-color:$box-style-bg-color;
  border-color:$box-style-border-color;
  color:$box-style-text-color;
  .form-actions {
    border-color: darken($box-style-bg-color, 5%);
  }
}

// Box Style modifier hollow
@mixin box-style-mod-hollow($box-style-color: $box-style-default-style) {
  background-color: transparent;
  border-color: $box-style-color;
}

// ===================================================================================
// =================================== Box style rewrite =============================
// ===================================================================================

// TODO: How to automaticaly create a selector list of dark & light box-style classes?
// TODO: Maybe its easier and more flexible to use deeper sass maps for the box style definitions, see:
//       https://www.sitepoint.com/sass-responsive-typography/ ==> Static values for bgcolor, color, ...
//       Maybe bools to define override-border-colors, override-background-colors .... ?

// Box style content (text) color (light or dark determined by the given background-color)
@mixin contextual-contents-color($foreground-color, $background-color){
  // Headings
  @include headings-color($foreground-color);
  // Force foreground color
  .force-txt-fgcol{
    color: $foreground-color !important;
  }
  .force-bg-fgcol{
    background-color: $foreground-color !important;
  }
  .force-brd-fgcol{
    border-color: $foreground-color !important;
  }
  // Force background color
  .force-txt-bgcol{
    color: $background-color !important;
  }
  .force-bg-bgcol{
    background-color: $background-color !important;
  }
  .force-brd-bgcol{
    border-color: $background-color !important;
  }
  // Input elements foreground color(s) if "hollow"-style is configured
  @if($input-background==transparent) {
    // $input-background is a global variable - has nothing to do with box-style itself
    // Fix input element style if input background color is set to transparent (otherwise it could be unreadable)
    input:not(.button),
    select,
    textarea {
      border-color: $text-color;
      color: $text-color;
    }
  }
}

// Box style mod rewrite
@mixin webksdct-box-styles() {
  .box-style {
    @include box-style;

    // Box styles by class from box-style-palette
    // Hint: The box-style--nested class is set by jquery. We need this to ensure that the inner box-style dont get the colors from the outer one, if the CSS decleration of the outer one is defined later then the inner one (so it would override it)
    @each $box-style, $box-style-color in $box-style-palette {
      &--#{$box-style} {
        @include box-style-mod($box-style-color);
      }
      // Automaticaly detect the right text color
      // You can modify the automatism by chainging $box-style-smart-scale-threshold
      // You can also modify the default fore- and background-colors by changing $box-style-light-colors-foreground-color, ...
      // If you need a custom color use the contextual-contents-color() mixin.
      $box-style-text-color: smart-scale($box-style-color, 100%, $box-style-smart-scale-threshold); // Ensure we have a solid text color, even if the box-style-color is RGBA / transparent (increased the threshold a little to switch to white text a little earlier - 50% would work also)
      $box-style-text-color: rgba-to-rgb($box-style-text-color);
      @if($box-style-text-color==black or $box-style-text-color=="black") {
        $box-style-text-color: $body-font-color;
        &--#{$box-style} {
          @include contextual-contents-color(
            $foreground-color: if($box-style-light-colors-foreground-color == "current", $box-style-text-color, $box-style-light-colors-foreground-color),
            $background-color: if($box-style-light-colors-background-color == "current", $box-style-color, $box-style-light-colors-background-color)
          );
        }
      }
      @else if($box-style-text-color==white or $box-style-text-color=="white") {
        $box-style-text-color: $white;
        &--#{$box-style} {
          @include contextual-contents-color(
            $foreground-color: if($box-style-dark-colors-foreground-color == "current", $box-style-text-color, $box-style-dark-colors-foreground-color),
            $background-color: if($box-style-dark-colors-background-color == "current", $box-style-color, $box-style-dark-colors-background-color)
          );
        }
      }
    }
    // Hollow (just the border)
    @each $box-style, $box-style-color in $box-style-palette {
      &--hollow-#{$box-style} {
        @include box-style-mod-hollow($box-style-color);
      }
    }
  }
}

// =============================================================================
// Misc
// =============================================================================
// Cutlines
@mixin cutline($direction: bottom, $color: $cutline-default-color, $spacing-one: $cutline-default-space-v, $spacing-two: $cutline-default-space-v, $shadow-extend: null) {
  @if($direction==top) {
    // border-top: 1px solid $color;
    padding-top: $spacing-one;
    margin-top: $spacing-two;
    position: relative;
    &::before {
      content: "";
      display: block;
      height: 1px;
      top: 0;
      width: 100%;
      background-color: $color;
      position: absolute;
      @if($shadow-extend !=null) {
        box-shadow: (($global-width-px - $grid-gutter) * -1) 0 $color, ($global-width-px - $grid-gutter) 0 $color;
      }
    }
  }
  @else {
    // border-bottom: 1px solid $color;
    padding-bottom: $spacing-one;
    margin-bottom: $spacing-two;
    position: relative;
    &::after {
      content: "";
      display: block;
      height: 1px;
      bottom: 0;
      width: 100%;
      background-color: $color;
      position: absolute;
      @if($shadow-extend !=null) {
        box-shadow: (($global-width-px - $grid-gutter) * -1) 0 $color, ($global-width-px - $grid-gutter) 0 $color;
      }
    }
  }
}

@mixin cutline-vertical($direction: right, $color: $cutline-default-color, $spacing-one: $cutline-default-space-h, $spacing-two: $cutline-default-space-h) {
  @if($direction==left) {
    border-left: 1px solid $cutline-default-color;
    padding-left: $spacing-one;
    margin-left: $spacing-two;
  }
  @else {
    border-right: 1px solid $cutline-default-color;
    padding-right: $spacing-one;
    margin-right: $spacing-two;
  }
}
